#pragma once
#include "simpleimageshape.h"
#include "StateControl.h"
#include "ScriptletContainerFactory.h"

class CPartitionImageShape : public CSimpleImageShape
{
public:
	enum
	{
		E_PART_NORMAL = 0,
		E_PART_OVER,
		E_PART_PRESS,
		E_PART_DISABLE,
		E_PART_SELECT,
	};
	DECLARE_COMPONENT_CREATOR(CPartitionImageShape);
	CPartitionImageShape(void);
	virtual ~CPartitionImageShape(void);

	//override
	LPCTSTR GetClassName() { return SCRIPTLET_PARTITIONIMAGE_NODE; }
	BOOL GetOrginPreferredSize(LPSIZE lpSize);
	void OnAddNotify();
	void OnRemoveNotify();

	//operation
	void DrawComponent(HDC hDC);

	void SetPartition(int part);
	int GetPartition() { return m_nPartiton; }
	void SetSelectVisible(BOOL bVisible);
	BOOL IsSelectVisible() { return m_bSelectVisible; }

protected:
	void DrawPartImage( HDC hDC, CRect rcClient );

private:
	int m_nPartiton;
	int m_nCurrPart;
	BOOL m_bSelectVisible;

	CStateControl m_stateControl;
	CNControl* m_pParentControl;

	int GetPartIndex();
	int GetPushedPartIndex();
	int GetUnPushedPartIndex();
};

class CPartitionTileImageShape : public CPartitionImageShape
{
public:
	DECLARE_COMPONENT_CREATOR(CPartitionTileImageShape);
	CPartitionTileImageShape(void) {}
	virtual ~CPartitionTileImageShape(void) {}

	//override
	LPCTSTR GetClassName() { return SCRIPTLET_PARTITIONTILEIMAGE_NODE; }
	void DrawComponent(HDC hDC);
};
